## org.eclipse.emf.ecore.impl
Class EPackageImpl

    java.lang.Object
      org.eclipse.emf.common.notify.impl.BasicNotifierImpl
          org.eclipse.emf.ecore.impl.BasicEObjectImpl
              org.eclipse.emf.ecore.impl.MinimalEObjectImpl
                  org.eclipse.emf.ecore.impl.MinimalEObjectImpl.Container
                      org.eclipse.emf.ecore.impl.EModelElementImpl
                          org.eclipse.emf.ecore.impl.ENamedElementImpl
                              org.eclipse.emf.ecore.impl.EPackageImpl

All Implemented Interfaces:
  Notifier, EModelElement, ENamedElement, EObject, EPackage, EStructuralFeature.Internal.DynamicValueHolder, InternalEObject, BasicExtendedMetaData.EPackageExtendedMetaData.Holder

Direct Known Subclasses:
  ChangePackageImpl, Ecore2EcorePackageImpl, Ecore2XMLPackageImpl, EcorePackageImpl, GenModelPackageImpl, MappingPackageImpl, TreePackageImpl, XMLNamespacePackageImpl, XMLTypePackageImpl

    public class EPackageImpl

extends ENamedElementImpl
implements EPackage, BasicExtendedMetaData.EPackageExtendedMetaData.Holder

An implementation of the model object 'EPackage'.

Nested Class Summary

Nested classes/interfaces inherited from class org.eclipse.emf.ecore.impl.MinimalEObjectImpl.Container
`MinimalEObjectImpl.Container.Dynamic`

Nested classes/interfaces inherited from class org.eclipse.emf.ecore.impl.MinimalEObjectImpl
`MinimalEObjectImpl.Container`

Nested classes/interfaces inherited from class org.eclipse.emf.ecore.impl.BasicEObjectImpl
`BasicEObjectImpl.EPropertiesHolder, BasicEObjectImpl.EPropertiesHolderBaseImpl, BasicEObjectImpl.EPropertiesHolderImpl`

Nested classes/interfaces inherited from class org.eclipse.emf.common.notify.impl.BasicNotifierImpl
`BasicNotifierImpl.EAdapterList<E extends java.lang.Object & Adapter>`

Nested classes/interfaces inherited from interface org.eclipse.emf.ecore.EPackage
`EPackage.Descriptor, EPackage.Registry`

Nested classes/interfaces inherited from interface org.eclipse.emf.ecore.InternalEObject
`InternalEObject.EStore`

Field Summary
`protected EList<EClassifier>` `eClassifiers` The cached value of the '`EClassifiers`' containment reference list
`protected EcoreFactory` `ecoreFactory` The Ecore factory.
`protected EcorePackage` `ecorePackage` The Ecore factory.
`protected EFactory` `eFactoryInstance` The cached value of the '`EFactory Instance`' reference
`protected java.util.Map<java.lang.String,EClassifier>` `eNameToEClassifierMap` The map from name to
`protected BasicExtendedMetaData.EPackageExtendedMetaData` `ePackageExtendedMetaData`
`protected EList<EPackage>` `eSubpackages` The cached value of the '`ESubpackages`' containment reference list
`protected static boolean` `IS_ABSTRACT`
`protected static boolean` `IS_CHANGEABLE`
`protected static boolean` `IS_COMPOSITE`
`protected static boolean` `IS_DERIVED`
`protected static boolean` `IS_GENERATED_INSTANCE_CLASS`
`protected static boolean` `IS_ID`
`protected static boolean` `IS_INTERFACE`
`protected static boolean` `IS_ORDERED`
`protected static boolean` `IS_RESOLVABLE`
`protected static boolean` `IS_RESOLVE_PROXIES`
`protected static boolean` `IS_SERIALIZABLE`
`protected static boolean` `IS_TRANSIENT`
`protected static boolean` `IS_UNIQUE`
`protected static boolean` `IS_UNSETTABLE`
`protected static boolean` `IS_VOLATILE`
`protected static java.lang.String` `NS_PREFIX_EDEFAULT` The default value of the '`Ns Prefix`' attribute
`protected static java.lang.String` `NS_URI_EDEFAULT` The default value of the '`Ns URI`' attribute
`protected java.lang.String` `nsPrefix` The cached value of the '`Ns Prefix`' attribute
`protected java.lang.String` `nsURI` The cached value of the '`Ns URI`' attribute

Fields inherited from class org.eclipse.emf.ecore.impl.ENamedElementImpl
`name, NAME_EDEFAULT`

Fields inherited from class org.eclipse.emf.ecore.impl.EModelElementImpl
`eAnnotations, eFlags, EFROZEN, ELAST_EMODEL_ELEMENT_FLAG`

Fields inherited from class org.eclipse.emf.ecore.impl.MinimalEObjectImpl.Container
`eContainer`

Fields inherited from class org.eclipse.emf.ecore.impl.BasicEObjectImpl
`EVIRTUAL_GET, EVIRTUAL_IS_SET, EVIRTUAL_NO_VALUE, EVIRTUAL_SET, EVIRTUAL_UNSET`

Fields inherited from interface org.eclipse.emf.ecore.EStructuralFeature.Internal.DynamicValueHolder
`NIL`

Fields inherited from interface org.eclipse.emf.ecore.InternalEObject
`EOPPOSITE_FEATURE_BASE`

Constructor Summary
`protected` `EPackageImpl()` Creates an instance
`protected` `EPackageImpl(EFactory eFactory)` Creates an instance with a factory.
`protected` `EPackageImpl(java.lang.String packageURI)` Creates a `registered` instance that has a default factory.
`protected` `EPackageImpl(java.lang.String packageURI, EFactory factory)` Creates a `registered` instance with a factory.

Method Summary
`protected void` `addAnnotation(ENamedElement eNamedElement, int depth, java.lang.String source, java.lang.String[] details)`
`protected void` `addAnnotation(ENamedElement eNamedElement, int depth, java.lang.String source, java.lang.String[] details, URI[] references)`
`protected void` `addAnnotation(ENamedElement eNamedElement, java.lang.String source, java.lang.String[] details)`
`protected void` `addAnnotation(ENamedElement eNamedElement, java.lang.String source, java.lang.String[] details, URI[] references)`
`protected void` `addEEnumLiteral(EEnum owner, Enumerator e)`
`protected void` `addEException(EOperation owner, EClassifier exception)`
`protected void` `addEException(EOperation owner, EGenericType exception)`
`protected EOperation` `addEOperation(EClass owner, EClassifier type, java.lang.String name)`
`protected EOperation` `addEOperation(EClass owner, EClassifier type, java.lang.String name, int lowerBound, int upperBound)`
`protected EOperation` `addEOperation(EClass owner, EClassifier type, java.lang.String name, int lowerBound, int upperBound, boolean isUnique, boolean isOrdered)`
`protected void` `addEParameter(EOperation owner, EClassifier type, java.lang.String name)`
`protected void` `addEParameter(EOperation owner, EClassifier type, java.lang.String name, int lowerBound, int upperBound)`
`protected EParameter` `addEParameter(EOperation owner, EClassifier type, java.lang.String name, int lowerBound, int upperBound, boolean isUnique, boolean isOrdered)`
`protected void` `addEParameter(EOperation owner, EGenericType type, java.lang.String name, int lowerBound, int upperBound)` Deprecated.
`protected void` `addEParameter(EOperation owner, EGenericType type, java.lang.String name, int lowerBound, int upperBound, boolean isUnique, boolean isOrdered)`
`protected ETypeParameter` `addETypeParameter(EClassifier owner, java.lang.String name)`
`protected ETypeParameter` `addETypeParameter(EOperation owner, java.lang.String name)`
`EPackage` `basicGetESuperPackage()`
`NotificationChain` `basicSetEFactoryInstance(EFactory newEFactoryInstance, NotificationChain msgs)`
`protected void` `createEAttribute(EClass owner, int id)`
`protected EClass` `createEClass(int id)`
`protected EDataType` `createEDataType(int id)`
`protected EEnum` `createEEnum(int id)`
`protected EGenericType` `createEGenericType()`
`protected EGenericType` `createEGenericType(EClassifier eClassifier)`
`protected EGenericType` `createEGenericType(ETypeParameter eTypeParameter)`
`protected void` `createEOperation(EClass owner, int id)`
`protected void` `createEReference(EClass owner, int id)`
`protected Resource` `createResource(java.lang.String uri)`
`NotificationChain` `eBasicRemoveFromContainerFeature(NotificationChain msgs)`
`java.lang.Object` `eGet(int featureID, boolean resolve, boolean coreType)`
`NotificationChain` `eInverseAdd(InternalEObject otherEnd, int featureID, NotificationChain msgs)`
`NotificationChain` `eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs)`
`java.lang.Object` `eInvoke(int operationID, EList<?> arguments)`
`boolean` `eIsSet(int featureID)`
`EObject` `eObjectForURIFragmentSegment(java.lang.String uriFragmentSegment)` Returns the object resolved by the fragment segment.
`void` `eSet(int featureID, java.lang.Object newValue)`
`void` `eSetProxyURI(URI uri)` Set the proxy URI of this object.
`protected EClass` `eStaticClass()`
`void` `eUnset(int featureID)`
`protected void` `fixEClassifiers()`
`protected void` `fixEEnumLiterals(EEnum eEnum)`
`protected void` `fixEOperations(EClass eClass)`
`protected void` `fixEStructuralFeatures(EClass eClass)`
`protected void` `fixInstanceClass(EClassifier eClassifier)`
`void` `freeze()`
`EClassifier` `getEClassifier(java.lang.String name)` Returns the classifier with the given name.
`EClassifier` `getEClassifierGen(java.lang.String name)`
`EList<EClassifier>` `getEClassifiers()`
`EFactory` `getEFactoryInstance()`
`EList<EPackage>` `getESubpackages()`
`EPackage` `getESuperPackage()`
`BasicExtendedMetaData.EPackageExtendedMetaData` `getExtendedMetaData()`
`java.lang.String` `getNsPrefix()`
`java.lang.String` `getNsURI()`
`protected EAttribute` `initEAttribute(EAttribute a, EClassifier type, java.lang.String name, java.lang.String defaultValue, int lowerBound, int upperBound, boolean isTransient, boolean isVolatile, boolean isChangeable, boolean isUnsettable)` Deprecated.
`protected EAttribute` `initEAttribute(EAttribute a, EClassifier type, java.lang.String name, java.lang.String defaultValue, int lowerBound, int upperBound, boolean isTransient, boolean isVolatile, boolean isChangeable, boolean isUnsettable, boolean isID)` Deprecated.
`protected EAttribute` `initEAttribute(EAttribute a, EClassifier type, java.lang.String name, java.lang.String defaultValue, int lowerBound, int upperBound, boolean isTransient, boolean isVolatile, boolean isChangeable, boolean isUnsettable, boolean isID, boolean isUnique)` Deprecated.
`protected EAttribute` `initEAttribute(EAttribute a, EClassifier type, java.lang.String name, java.lang.String defaultValue, int lowerBound, int upperBound, boolean isTransient, boolean isVolatile, boolean isChangeable, boolean isUnsettable, boolean isID, boolean isUnique, boolean isDerived)`
`protected EAttribute` `initEAttribute(EAttribute a, EClassifier type, java.lang.String name, java.lang.String defaultValue, int lowerBound, int upperBound, boolean isTransient, boolean isVolatile, boolean isChangeable, boolean isUnsettable, boolean isID, boolean isUnique, boolean isDerived, boolean isOrdered)`
`protected EAttribute` `initEAttribute(EAttribute a, EClassifier type, java.lang.String name, java.lang.String defaultValue, int lowerBound, int upperBound, java.lang.Class<?> containerClass, boolean isTransient, boolean isVolatile, boolean isChangeable, boolean isUnsettable, boolean isID, boolean isUnique, boolean isDerived, boolean isOrdered)`
`protected EAttribute` `initEAttribute(EAttribute a, EGenericType type, java.lang.String name, java.lang.String defaultValue, int lowerBound, int upperBound, java.lang.Class<?> containerClass, boolean isTransient, boolean isVolatile, boolean isChangeable, boolean isUnsettable, boolean isID, boolean isUnique, boolean isDerived, boolean isOrdered)`
`protected EClass` `initEClass(EClass c, java.lang.Class<?> instanceClass, java.lang.String name, boolean isAbstract, boolean isInterface)`
`protected EClass` `initEClass(EClass c, java.lang.Class<?> instanceClass, java.lang.String name, boolean isAbstract, boolean isInterface, boolean isGenerated)`
`protected EClass` `initEClass(EClass c, java.lang.Class<?> instanceClass, java.lang.String name, boolean isAbstract, boolean isInterface, boolean isGenerated, java.lang.String instanceTypeName)`
`protected EDataType` `initEDataType(EDataType d, java.lang.Class<?> instanceClass, java.lang.String name, boolean isSerializable)`
`protected EDataType` `initEDataType(EDataType d, java.lang.Class<?> instanceClass, java.lang.String name, boolean isSerializable, boolean isGenerated)`
`protected EDataType` `initEDataType(EDataType d, java.lang.Class<?> instanceClass, java.lang.String name, boolean isSerializable, boolean isGenerated, java.lang.String instanceTypeName)`
`protected EEnum` `initEEnum(EEnum e, java.lang.Class<?> instanceClass, java.lang.String name)`
`protected EOperation` `initEOperation(EOperation eOperation, EClassifier type, java.lang.String name)`
`protected EOperation` `initEOperation(EOperation eOperation, EClassifier type, java.lang.String name, int lowerBound, int upperBound)`
`protected EOperation` `initEOperation(EOperation eOperation, EClassifier type, java.lang.String name, int lowerBound, int upperBound, boolean isUnique, boolean isOrdered)`
`protected void` `initEOperation(EOperation eOperation, EGenericType eGenericType)`
`protected EReference` `initEReference(EReference r, EClassifier type, EReference otherEnd, java.lang.String name, java.lang.String defaultValue, int lowerBound, int upperBound, boolean isTransient, boolean isVolatile, boolean isChangeable, boolean isContainment, boolean isResolveProxies)` Deprecated.
`protected EReference` `initEReference(EReference r, EClassifier type, EReference otherEnd, java.lang.String name, java.lang.String defaultValue, int lowerBound, int upperBound, boolean isTransient, boolean isVolatile, boolean isChangeable, boolean isContainment, boolean isResolveProxies, boolean isUnsettable)` Deprecated.
`protected EReference` `initEReference(EReference r, EClassifier type, EReference otherEnd, java.lang.String name, java.lang.String defaultValue, int lowerBound, int upperBound, boolean isTransient, boolean isVolatile, boolean isChangeable, boolean isContainment, boolean isResolveProxies, boolean isUnsettable, boolean isUnique)` Deprecated.
`protected EReference` `initEReference(EReference r, EClassifier type, EReference otherEnd, java.lang.String name, java.lang.String defaultValue, int lowerBound, int upperBound, boolean isTransient, boolean isVolatile, boolean isChangeable, boolean isContainment, boolean isResolveProxies, boolean isUnsettable, boolean isUnique, boolean isDerived)`
`protected EReference` `initEReference(EReference r, EClassifier type, EReference otherEnd, java.lang.String name, java.lang.String defaultValue, int lowerBound, int upperBound, boolean isTransient, boolean isVolatile, boolean isChangeable, boolean isContainment, boolean isResolveProxies, boolean isUnsettable, boolean isUnique, boolean isDerived, boolean isOrdered)`

`protected EReference`

`initEReference(EReference r, EClassifier type, EReference otherEnd, java.lang.String name, java.lang.String defaultValue, int lowerBound, int upperBound, java.lang.Class<?> containerClass, boolean isTransient, boolean isVolatile, boolean isChangeable, boolean isContainment, boolean isResolveProxies, boolean isUnsettable, boolean isUnique, boolean isDerived, boolean isOrdered)`

`protected EReference`

`initEReference(EReference r, EGenericType type, EReference otherEnd, java.lang.String name, java.lang.String defaultValue, int lowerBound, int upperBound, java.lang.Class<?> containerClass, boolean isTransient, boolean isVolatile, boolean isChangeable, boolean isContainment, boolean isResolveProxies, boolean isUnsettable, boolean isUnique, boolean isDerived, boolean isOrdered)`

`protected void` `initializeFromLoadedEPackage(EPackage target, EPackage source)`
`void` `setEFactoryInstance(EFactory newEFactoryInstance)`
`void` `setExtendedMetaData(BasicExtendedMetaData.EPackageExtendedMetaData ePackageExtendedMetaData)`
`protected void` `setGeneratedClassName(EClassifier eClassifier)`
`protected void` `setInstanceTypeName(EClassifier eClassifier, java.lang.String instanceTypeName)`
`void` `setNamespaceURI(java.lang.String nsURI)` Deprecated.
`void` `setNsPrefix(java.lang.String newNsPrefix)`
`void` `setNsURI(java.lang.String newNsURI)`
`java.lang.String` `toString()`

Methods inherited from class org.eclipse.emf.ecore.impl.ENamedElementImpl
`eContents, eCrossReferences, getName, getNameGen, setName`

Methods inherited from class org.eclipse.emf.ecore.impl.EModelElementImpl
`eSetDirectResource, eURIFragmentSegment, freeze, getEAnnotation, getEAnnotations, isFrozen, setFrozen`

Methods inherited from class org.eclipse.emf.ecore.impl.MinimalEObjectImpl.Container
`eBasicSetContainer, eInternalContainer`

Methods inherited from class org.eclipse.emf.ecore.impl.MinimalEObjectImpl
`dynamicGet, dynamicSet, dynamicUnset, eAdapters, eBasicAdapterArray, eBasicAdapters, eBasicHasAdapters, eBasicProperties, eBasicSetAdapterArray, eBasicSetContainer, eBasicSetContainerFeatureID, eBasicSetSettings, eBasicSettings, eClass, eContainerFeatureID, eDeliver, eDirectResource, eDynamicClass, eHasSettings, eIsProxy, eProperties, eProxyURI, eSetClass, eSetDeliver, eSettings`

Methods inherited from class org.eclipse.emf.ecore.impl.BasicEObjectImpl

`eAddVirtualValue, eAllContents, eBaseStructuralFeatureID, eBasicRemoveFromContainer, eBasicSetContainer, eComputeVirtualValuesCapacity, eContainer, eContainerAdapterArray, eContainingFeature, eContainmentFeature, eContainmentFeature, eContains, eDerivedOperationID, eDerivedOperationID, eDerivedStructuralFeatureID, eDerivedStructuralFeatureID, eDynamicBasicRemoveFromContainer, eDynamicFeature, eDynamicFeatureID, eDynamicGet, eDynamicGet, eDynamicGet, eDynamicInverseAdd, eDynamicInverseAdd, eDynamicInverseRemove, eDynamicInverseRemove, eDynamicInvoke, eDynamicInvoke, eDynamicIsSet, eDynamicIsSet, eDynamicIsSet, eDynamicSet, eDynamicSet, eDynamicSet, eDynamicUnset, eDynamicUnset, eDynamicUnset, eGet, eGet, eGet, eInternalResource, eInverseAdd, eInverseRemove, eInvocationDelegate, eInvoke, eIsSet, eOpenGet, eOpenIsSet, eOpenSet, eOpenUnset, eRemoveVirtualValue, eResolveProxy, eResource, eSet, eSetResource, eSetStore, eSetting, eSettingDelegate, eSetVirtualIndexBits, eSetVirtualValue, eSetVirtualValues, eStaticFeatureCount, eStaticOperationCount, eStore, eUnset, eVirtualBitCount, eVirtualGet, eVirtualGet, eVirtualIndex, eVirtualIndexBits, eVirtualIsSet, eVirtualSet, eVirtualUnset, eVirtualValue, eVirtualValues`

Methods inherited from class org.eclipse.emf.common.notify.impl.BasicNotifierImpl
`eNotificationRequired, eNotify`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Methods inherited from interface org.eclipse.emf.ecore.ENamedElement
`getName, setName`

Methods inherited from interface org.eclipse.emf.ecore.EModelElement
`getEAnnotation, getEAnnotations`

Methods inherited from interface org.eclipse.emf.ecore.EObject
`eAllContents, eClass, eContainer, eContainingFeature, eContainmentFeature, eContents, eCrossReferences, eGet, eGet, eInvoke, eIsProxy, eIsSet, eResource, eSet, eUnset`

Methods inherited from interface org.eclipse.emf.common.notify.Notifier
`eAdapters, eDeliver, eNotify, eSetDeliver`

Methods inherited from interface org.eclipse.emf.ecore.InternalEObject
`eNotificationRequired`

Field Detail

### NS_URI_EDEFAULT

    protected static final java.lang.String NS_URI_EDEFAULT

  The default value of the '`Ns URI`' attribute.

  See Also:
    `getNsURI()`

### ecoreFactory

    protected EcoreFactory ecoreFactory

  The Ecore factory.

### ecorePackage

    protected EcorePackage ecorePackage

  The Ecore factory.

### eNameToEClassifierMap

    protected java.util.Map<java.lang.String,EClassifier> eNameToEClassifierMap

  The map from name to

### nsURI

    protected java.lang.String nsURI

  The cached value of the '`Ns URI`' attribute.

  See Also:
    `getNsURI()`

### NS_PREFIX_EDEFAULT

    protected static final java.lang.String NS_PREFIX_EDEFAULT

  The default value of the '`Ns Prefix`' attribute.

  See Also:
    `getNsPrefix()`

### nsPrefix

    protected java.lang.String nsPrefix

  The cached value of the '`Ns Prefix`' attribute.

  See Also:
    `getNsPrefix()`

### eFactoryInstance

    protected EFactory eFactoryInstance

  The cached value of the '`EFactory Instance`' reference.

  See Also:
    `getEFactoryInstance()`

### eClassifiers

    protected EList<EClassifier> eClassifiers

  The cached value of the '`EClassifiers`' containment reference list.

  See Also:
    `getEClassifiers()`

### eSubpackages

    protected EList<EPackage> eSubpackages

  The cached value of the '`ESubpackages`' containment reference list.

  See Also:
    `getESubpackages()`

### IS_ABSTRACT

    protected static final boolean IS_ABSTRACT

See Also:
  Constant Field Values

### IS_INTERFACE

    protected static final boolean IS_INTERFACE

See Also:
  Constant Field Values

### IS_GENERATED_INSTANCE_CLASS

    protected static final boolean IS_GENERATED_INSTANCE_CLASS

See Also:
  Constant Field Values

### IS_SERIALIZABLE

    protected static final boolean IS_SERIALIZABLE

See Also:
  Constant Field Values

### IS_DERIVED

    protected static final boolean IS_DERIVED

See Also:
  Constant Field Values

### IS_TRANSIENT

    protected static final boolean IS_TRANSIENT

See Also:
  Constant Field Values

### IS_VOLATILE

    protected static final boolean IS_VOLATILE

See Also:
  Constant Field Values

### IS_CHANGEABLE

    protected static final boolean IS_CHANGEABLE

See Also:
  Constant Field Values

### IS_UNSETTABLE

    protected static final boolean IS_UNSETTABLE

See Also:
  Constant Field Values

### IS_UNIQUE

    protected static final boolean IS_UNIQUE

See Also:
  Constant Field Values

### IS_ID

    protected static final boolean IS_ID

See Also:
  Constant Field Values

### IS_ORDERED

    protected static final boolean IS_ORDERED

See Also:
  Constant Field Values

### IS_COMPOSITE

    protected static final boolean IS_COMPOSITE

See Also:
  Constant Field Values

### IS_RESOLVE_PROXIES

    protected static final boolean IS_RESOLVE_PROXIES

See Also:
  Constant Field Values

### IS_RESOLVABLE

    protected static final boolean IS_RESOLVABLE

See Also:
  Constant Field Values

### ePackageExtendedMetaData

    protected BasicExtendedMetaData.EPackageExtendedMetaData ePackageExtendedMetaData

Constructor Detail

### EPackageImpl

    protected EPackageImpl()

  Creates an instance.

### EPackageImpl

    protected EPackageImpl(EFactory eFactory)

  Creates an instance with a factory.

  Parameters:
    `eFactory` - the factory of the new package.

### EPackageImpl

    protected EPackageImpl(java.lang.String packageURI)

  Creates a `registered` instance that has a default factory.

  Parameters:
    `packageURI` - the registered `namespace URI` of the new package.

### EPackageImpl

    protected EPackageImpl(java.lang.String packageURI,
                           EFactory factory)

  Creates a `registered` instance with a factory.

  Parameters:
    `packageURI` - the registered `namespace URI` of the new package.
    `factory` - the factory of the new package.

Method Detail

### freeze

    public void freeze()

  Overrides:
    `freeze` in class `EModelElementImpl`

### eSetProxyURI

    public void eSetProxyURI(URI uri)

  Description copied from interface: `InternalEObject`
  Set the proxy URI of this object. It will be used to `resolve` to the actual object.

  Specified by:
    `eSetProxyURI` in interface `InternalEObject`
  Overrides:
    `eSetProxyURI` in class `MinimalEObjectImpl`
  Parameters:
    `uri` - the URI.
  See Also:
    `EcoreUtil.resolve(EObject, org.eclipse.emf.ecore.resource.ResourceSet)`, `Resource.unload()`

### eStaticClass

    protected EClass eStaticClass()

  Overrides:
    `eStaticClass` in class `ENamedElementImpl`

### setNamespaceURI

    @Deprecated
    public void setNamespaceURI(java.lang.String nsURI)

  Deprecated.

### getNsURI

    public java.lang.String getNsURI()

  Specified by:
    `getNsURI` in interface `EPackage`
  Returns:
    the value of the 'Ns URI' attribute.
  See Also:
    `EPackage.Registry.INSTANCE`, `EPackage.setNsURI(String)`, `EcorePackage.getEPackage_NsURI()`

### setNsURI

    public void setNsURI(java.lang.String newNsURI)

  Specified by:
    `setNsURI` in interface `EPackage`
  Parameters:
    `newNsURI` - the new value of the 'Ns URI' attribute.
  See Also:
    `EPackage.getNsURI()`

### getNsPrefix

    public java.lang.String getNsPrefix()

  Specified by:
    `getNsPrefix` in interface `EPackage`
  Returns:
    the value of the 'Ns Prefix' attribute.
  See Also:
    `EPackage.setNsPrefix(String)`, `EcorePackage.getEPackage_NsPrefix()`

### setNsPrefix

    public void setNsPrefix(java.lang.String newNsPrefix)

  Specified by:
    `setNsPrefix` in interface `EPackage`
  Parameters:
    `newNsPrefix` - the new value of the 'Ns Prefix' attribute.
  See Also:
    `EPackage.getNsPrefix()`

### getEFactoryInstance

    public EFactory getEFactoryInstance()

  Specified by:
    `getEFactoryInstance` in interface `EPackage`
  Returns:
    the value of the 'EFactory Instance' reference.
  See Also:
    `EPackage.setEFactoryInstance(EFactory)`, `EcorePackage.getEPackage_EFactoryInstance()`, `EFactory.getEPackage()`

### setEFactoryInstance

    public void setEFactoryInstance(EFactory newEFactoryInstance)

  Specified by:
    `setEFactoryInstance` in interface `EPackage`
  Parameters:
    `newEFactoryInstance` - the new value of the 'EFactory Instance' reference.
  See Also:
    `EPackage.getEFactoryInstance()`

### basicSetEFactoryInstance

    public NotificationChain basicSetEFactoryInstance(EFactory newEFactoryInstance,
                                                      NotificationChain msgs)

### getEClassifiers

    public EList<EClassifier> getEClassifiers()

  Specified by:
    `getEClassifiers` in interface `EPackage`
  Returns:
    the value of the 'EClassifiers' containment reference list.
  See Also:
    `EcorePackage.getEPackage_EClassifiers()`, `EClassifier.getEPackage()`

### getEClassifier

    public EClassifier getEClassifier(java.lang.String name)

  Description copied from interface: `EPackage`
  Returns the classifier with the given name.

  Specified by:
    `getEClassifier` in interface `EPackage`
  Parameters:
    `name` - the name in question.
  Returns:
    the classifier with the given name.

### getEClassifierGen

    public EClassifier getEClassifierGen(java.lang.String name)

### eInverseAdd

    public NotificationChain eInverseAdd(InternalEObject otherEnd,
                                         int featureID,
                                         NotificationChain msgs)

  Overrides:
    `eInverseAdd` in class `EModelElementImpl`

### eInverseRemove

    public NotificationChain eInverseRemove(InternalEObject otherEnd,
                                            int featureID,
                                            NotificationChain msgs)

  Overrides:
    `eInverseRemove` in class `EModelElementImpl`

### eBasicRemoveFromContainerFeature

    public NotificationChain eBasicRemoveFromContainerFeature(NotificationChain msgs)

  Overrides:
    `eBasicRemoveFromContainerFeature` in class `BasicEObjectImpl`

### getESubpackages

    public EList<EPackage> getESubpackages()

  Specified by:
    `getESubpackages` in interface `EPackage`
  Returns:
    the value of the 'ESubpackages' containment reference list.
  See Also:
    `EcorePackage.getEPackage_ESubpackages()`, `EPackage.getESuperPackage()`

### getESuperPackage

    public EPackage getESuperPackage()

  Specified by:
    `getESuperPackage` in interface `EPackage`
  Returns:
    the value of the 'ESuper Package' container reference.
  See Also:
    `EcorePackage.getEPackage_ESuperPackage()`, `EPackage.getESubpackages()`

### basicGetESuperPackage

    public EPackage basicGetESuperPackage()

### eGet

    public java.lang.Object eGet(int featureID,
                                 boolean resolve,
                                 boolean coreType)

  Specified by:
    `eGet` in interface `InternalEObject`
  Overrides:
    `eGet` in class `ENamedElementImpl`
  See Also:
    `InternalEObject.eGet(EStructuralFeature, boolean, boolean)`

### eSet

    public void eSet(int featureID,
                     java.lang.Object newValue)

  Specified by:
    `eSet` in interface `InternalEObject`
  Overrides:
    `eSet` in class `ENamedElementImpl`
  See Also:
    `EObject.eSet(EStructuralFeature, Object)`

### eUnset

    public void eUnset(int featureID)

  Specified by:
    `eUnset` in interface `InternalEObject`
  Overrides:
    `eUnset` in class `ENamedElementImpl`
  See Also:
    `EObject.eUnset(EStructuralFeature)`

### eIsSet

    public boolean eIsSet(int featureID)

  Specified by:
    `eIsSet` in interface `InternalEObject`
  Overrides:
    `eIsSet` in class `ENamedElementImpl`
  See Also:
    `EObject.eIsSet(EStructuralFeature)`

### eInvoke

    public java.lang.Object eInvoke(int operationID,
                                    EList<?> arguments)
                             throws java.lang.reflect.InvocationTargetException

  Specified by:
    `eInvoke` in interface `InternalEObject`
  Overrides:
    `eInvoke` in class `EModelElementImpl`
  Throws:
    `java.lang.reflect.InvocationTargetException`
  See Also:
    `EObject.eInvoke(EOperation, EList<?>)`

### toString

    public java.lang.String toString()

  Overrides:
    `toString` in class `ENamedElementImpl`

### createResource

    protected Resource createResource(java.lang.String uri)

### createEClass

    protected EClass createEClass(int id)

### createEEnum

    protected EEnum createEEnum(int id)

### createEDataType

    protected EDataType createEDataType(int id)

### createEAttribute

    protected void createEAttribute(EClass owner,
                                    int id)

### createEReference

    protected void createEReference(EClass owner,
                                    int id)

### createEOperation

    protected void createEOperation(EClass owner,
                                    int id)

  Since:
    2.6

### addETypeParameter

    protected ETypeParameter addETypeParameter(EClassifier owner,
                                               java.lang.String name)

### addETypeParameter

    protected ETypeParameter addETypeParameter(EOperation owner,
                                               java.lang.String name)

### createEGenericType

    protected EGenericType createEGenericType()

### createEGenericType

    protected EGenericType createEGenericType(ETypeParameter eTypeParameter)

### createEGenericType

    protected EGenericType createEGenericType(EClassifier eClassifier)

### initEClass

    protected EClass initEClass(EClass c,
                                java.lang.Class<?> instanceClass,
                                java.lang.String name,
                                boolean isAbstract,
                                boolean isInterface)

### initEClass

    protected EClass initEClass(EClass c,
                                java.lang.Class<?> instanceClass,
                                java.lang.String name,
                                boolean isAbstract,
                                boolean isInterface,
                                boolean isGenerated)

### initEClass

    protected EClass initEClass(EClass c,
                                java.lang.Class<?> instanceClass,
                                java.lang.String name,
                                boolean isAbstract,
                                boolean isInterface,
                                boolean isGenerated,
                                java.lang.String instanceTypeName)

### initEEnum

    protected EEnum initEEnum(EEnum e,
                              java.lang.Class<?> instanceClass,
                              java.lang.String name)

### initEDataType

    protected EDataType initEDataType(EDataType d,
                                      java.lang.Class<?> instanceClass,
                                      java.lang.String name,
                                      boolean isSerializable)

### initEDataType

    protected EDataType initEDataType(EDataType d,
                                      java.lang.Class<?> instanceClass,
                                      java.lang.String name,
                                      boolean isSerializable,
                                      boolean isGenerated)

### initEDataType

    protected EDataType initEDataType(EDataType d,
                                      java.lang.Class<?> instanceClass,
                                      java.lang.String name,
                                      boolean isSerializable,
                                      boolean isGenerated,
                                      java.lang.String instanceTypeName)

### setGeneratedClassName

    protected void setGeneratedClassName(EClassifier eClassifier)

### setInstanceTypeName

    protected void setInstanceTypeName(EClassifier eClassifier,
                                       java.lang.String instanceTypeName)

### initEAttribute

    @Deprecated
    protected EAttribute initEAttribute(EAttribute a,
                                                   EClassifier type,
                                                   java.lang.String name,
                                                   java.lang.String defaultValue,
                                                   int lowerBound,
                                                   int upperBound,
                                                   boolean isTransient,
                                                   boolean isVolatile,
                                                   boolean isChangeable,
                                                   boolean isUnsettable)

  Deprecated.

### initEAttribute

    @Deprecated
    protected EAttribute initEAttribute(EAttribute a,
                                                   EClassifier type,
                                                   java.lang.String name,
                                                   java.lang.String defaultValue,
                                                   int lowerBound,
                                                   int upperBound,
                                                   boolean isTransient,
                                                   boolean isVolatile,
                                                   boolean isChangeable,
                                                   boolean isUnsettable,
                                                   boolean isID)

  Deprecated.

### initEAttribute

    @Deprecated
    protected EAttribute initEAttribute(EAttribute a,
                                                   EClassifier type,
                                                   java.lang.String name,
                                                   java.lang.String defaultValue,
                                                   int lowerBound,
                                                   int upperBound,
                                                   boolean isTransient,
                                                   boolean isVolatile,
                                                   boolean isChangeable,
                                                   boolean isUnsettable,
                                                   boolean isID,
                                                   boolean isUnique)

  Deprecated.

### initEAttribute

    protected EAttribute initEAttribute(EAttribute a,
                                        EClassifier type,
                                        java.lang.String name,
                                        java.lang.String defaultValue,
                                        int lowerBound,
                                        int upperBound,
                                        boolean isTransient,
                                        boolean isVolatile,
                                        boolean isChangeable,
                                        boolean isUnsettable,
                                        boolean isID,
                                        boolean isUnique,
                                        boolean isDerived)

### initEAttribute

    protected EAttribute initEAttribute(EAttribute a,
                                        EClassifier type,
                                        java.lang.String name,
                                        java.lang.String defaultValue,
                                        int lowerBound,
                                        int upperBound,
                                        boolean isTransient,
                                        boolean isVolatile,
                                        boolean isChangeable,
                                        boolean isUnsettable,
                                        boolean isID,
                                        boolean isUnique,
                                        boolean isDerived,
                                        boolean isOrdered)

### initEAttribute

    protected EAttribute initEAttribute(EAttribute a,
                                        EClassifier type,
                                        java.lang.String name,
                                        java.lang.String defaultValue,
                                        int lowerBound,
                                        int upperBound,
                                        java.lang.Class<?> containerClass,
                                        boolean isTransient,
                                        boolean isVolatile,
                                        boolean isChangeable,
                                        boolean isUnsettable,
                                        boolean isID,
                                        boolean isUnique,
                                        boolean isDerived,
                                        boolean isOrdered)

### initEAttribute

    protected EAttribute initEAttribute(EAttribute a,
                                        EGenericType type,
                                        java.lang.String name,
                                        java.lang.String defaultValue,
                                        int lowerBound,
                                        int upperBound,
                                        java.lang.Class<?> containerClass,
                                        boolean isTransient,
                                        boolean isVolatile,
                                        boolean isChangeable,
                                        boolean isUnsettable,
                                        boolean isID,
                                        boolean isUnique,
                                        boolean isDerived,
                                        boolean isOrdered)

### initEReference

    @Deprecated
    protected EReference initEReference(EReference r,
                                                   EClassifier type,
                                                   EReference otherEnd,
                                                   java.lang.String name,
                                                   java.lang.String defaultValue,
                                                   int lowerBound,
                                                   int upperBound,
                                                   boolean isTransient,
                                                   boolean isVolatile,
                                                   boolean isChangeable,
                                                   boolean isContainment,
                                                   boolean isResolveProxies)

  Deprecated.

### initEReference

    @Deprecated
    protected EReference initEReference(EReference r,
                                                   EClassifier type,
                                                   EReference otherEnd,
                                                   java.lang.String name,
                                                   java.lang.String defaultValue,
                                                   int lowerBound,
                                                   int upperBound,
                                                   boolean isTransient,
                                                   boolean isVolatile,
                                                   boolean isChangeable,
                                                   boolean isContainment,
                                                   boolean isResolveProxies,
                                                   boolean isUnsettable)

  Deprecated.

### initEReference

    @Deprecated
    protected EReference initEReference(EReference r,
                                                   EClassifier type,
                                                   EReference otherEnd,
                                                   java.lang.String name,
                                                   java.lang.String defaultValue,
                                                   int lowerBound,
                                                   int upperBound,
                                                   boolean isTransient,
                                                   boolean isVolatile,
                                                   boolean isChangeable,
                                                   boolean isContainment,
                                                   boolean isResolveProxies,
                                                   boolean isUnsettable,
                                                   boolean isUnique)

  Deprecated.

### initEReference

    protected EReference initEReference(EReference r,
                                        EClassifier type,
                                        EReference otherEnd,
                                        java.lang.String name,
                                        java.lang.String defaultValue,
                                        int lowerBound,
                                        int upperBound,
                                        boolean isTransient,
                                        boolean isVolatile,
                                        boolean isChangeable,
                                        boolean isContainment,
                                        boolean isResolveProxies,
                                        boolean isUnsettable,
                                        boolean isUnique,
                                        boolean isDerived)

### initEReference

    protected EReference initEReference(EReference r,
                                        EClassifier type,
                                        EReference otherEnd,
                                        java.lang.String name,
                                        java.lang.String defaultValue,
                                        int lowerBound,
                                        int upperBound,
                                        boolean isTransient,
                                        boolean isVolatile,
                                        boolean isChangeable,
                                        boolean isContainment,
                                        boolean isResolveProxies,
                                        boolean isUnsettable,
                                        boolean isUnique,
                                        boolean isDerived,
                                        boolean isOrdered)

### initEReference

    protected EReference initEReference(EReference r,
                                        EClassifier type,
                                        EReference otherEnd,
                                        java.lang.String name,
                                        java.lang.String defaultValue,
                                        int lowerBound,
                                        int upperBound,
                                        java.lang.Class<?> containerClass,
                                        boolean isTransient,
                                        boolean isVolatile,
                                        boolean isChangeable,
                                        boolean isContainment,
                                        boolean isResolveProxies,
                                        boolean isUnsettable,
                                        boolean isUnique,
                                        boolean isDerived,
                                        boolean isOrdered)

### initEReference

    protected EReference initEReference(EReference r,
                                        EGenericType type,
                                        EReference otherEnd,
                                        java.lang.String name,
                                        java.lang.String defaultValue,
                                        int lowerBound,
                                        int upperBound,
                                        java.lang.Class<?> containerClass,
                                        boolean isTransient,
                                        boolean isVolatile,
                                        boolean isChangeable,
                                        boolean isContainment,
                                        boolean isResolveProxies,
                                        boolean isUnsettable,
                                        boolean isUnique,
                                        boolean isDerived,
                                        boolean isOrdered)

### addEOperation

    protected EOperation addEOperation(EClass owner,
                                       EClassifier type,
                                       java.lang.String name)

### addEOperation

    protected EOperation addEOperation(EClass owner,
                                       EClassifier type,
                                       java.lang.String name,
                                       int lowerBound,
                                       int upperBound)

### addEOperation

    protected EOperation addEOperation(EClass owner,
                                       EClassifier type,
                                       java.lang.String name,
                                       int lowerBound,
                                       int upperBound,
                                       boolean isUnique,
                                       boolean isOrdered)

### initEOperation

    protected EOperation initEOperation(EOperation eOperation,
                                        EClassifier type,
                                        java.lang.String name)

  Since:
    2.6

### initEOperation

    protected EOperation initEOperation(EOperation eOperation,
                                        EClassifier type,
                                        java.lang.String name,
                                        int lowerBound,
                                        int upperBound)

  Since:
    2.6

### initEOperation

    protected EOperation initEOperation(EOperation eOperation,
                                        EClassifier type,
                                        java.lang.String name,
                                        int lowerBound,
                                        int upperBound,
                                        boolean isUnique,
                                        boolean isOrdered)

  Since:
    2.6

### initEOperation

    protected void initEOperation(EOperation eOperation,
                                  EGenericType eGenericType)

### addEParameter

    protected void addEParameter(EOperation owner,
                                 EClassifier type,
                                 java.lang.String name)

### addEParameter

    protected void addEParameter(EOperation owner,
                                 EClassifier type,
                                 java.lang.String name,
                                 int lowerBound,
                                 int upperBound)

### addEParameter

    protected EParameter addEParameter(EOperation owner,
                                       EClassifier type,
                                       java.lang.String name,
                                       int lowerBound,
                                       int upperBound,
                                       boolean isUnique,
                                       boolean isOrdered)

### addEParameter

    @Deprecated
    protected void addEParameter(EOperation owner,
                                            EGenericType type,
                                            java.lang.String name,
                                            int lowerBound,
                                            int upperBound)

  Deprecated.

### addEParameter

    protected void addEParameter(EOperation owner,
                                 EGenericType type,
                                 java.lang.String name,
                                 int lowerBound,
                                 int upperBound,
                                 boolean isUnique,
                                 boolean isOrdered)

### addEException

    protected void addEException(EOperation owner,
                                 EClassifier exception)

### addEException

    protected void addEException(EOperation owner,
                                 EGenericType exception)

### addEEnumLiteral

    protected void addEEnumLiteral(EEnum owner,
                                   Enumerator e)

### addAnnotation

    protected void addAnnotation(ENamedElement eNamedElement,
                                 java.lang.String source,
                                 java.lang.String[] details)

### addAnnotation

    protected void addAnnotation(ENamedElement eNamedElement,
                                 java.lang.String source,
                                 java.lang.String[] details,
                                 URI[] references)

### addAnnotation

    protected void addAnnotation(ENamedElement eNamedElement,
                                 int depth,
                                 java.lang.String source,
                                 java.lang.String[] details)

### addAnnotation

    protected void addAnnotation(ENamedElement eNamedElement,
                                 int depth,
                                 java.lang.String source,
                                 java.lang.String[] details,
                                 URI[] references)

### initializeFromLoadedEPackage

    protected void initializeFromLoadedEPackage(EPackage target,
                                                EPackage source)

### fixEClassifiers

    protected void fixEClassifiers()

### fixInstanceClass

    protected void fixInstanceClass(EClassifier eClassifier)

### fixEStructuralFeatures

    protected void fixEStructuralFeatures(EClass eClass)

### fixEOperations

    protected void fixEOperations(EClass eClass)

  Since:
    2.6

### fixEEnumLiterals

    protected void fixEEnumLiterals(EEnum eEnum)

### getExtendedMetaData

    public BasicExtendedMetaData.EPackageExtendedMetaData getExtendedMetaData()

  Specified by:
    `getExtendedMetaData` in interface `BasicExtendedMetaData.EPackageExtendedMetaData.Holder`

### setExtendedMetaData

    public void setExtendedMetaData(BasicExtendedMetaData.EPackageExtendedMetaData ePackageExtendedMetaData)

  Specified by:
    `setExtendedMetaData` in interface `BasicExtendedMetaData.EPackageExtendedMetaData.Holder`

### eObjectForURIFragmentSegment

    public EObject eObjectForURIFragmentSegment(java.lang.String uriFragmentSegment)

  Description copied from interface: `InternalEObject`
  Returns the object resolved by the fragment segment.

  The fragment segment encoding will typically be of the form returned by `eURIFragmentSegment`.

  Specified by:
    `eObjectForURIFragmentSegment` in interface `InternalEObject`
  Overrides:
    `eObjectForURIFragmentSegment` in class `EModelElementImpl`
  Parameters:
    `uriFragmentSegment` - a fragment segment.
  Returns:
    the fragment segment that resolves to the given object in this object's given feature.

Copyright 2001-2006 IBM Corporation and others. All Rights Reserved.